//+------------------------------------------------------------------+
//|                                                         Fatl.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
//----  
#property copyright "2010, MetaQuotes Software Corp."
//----    
#property link      "http://www.mql5.com"
//----   
#property version   "2.00"
//----     
#property indicator_chart_window
//----        
#property indicator_buffers 1
//----     
#property indicator_plots   1
//----     
#property indicator_type1   DRAW_LINE
//----        
#property indicator_color1  Blue
//----   -  
#property indicator_style1  STYLE_SOLID
//----     2
#property indicator_width1  2
//----   
#property indicator_label1  "FATL"

//----   
input int FATLShift = 0; //       

//----         
int FATLPeriod;

//----   ,    
                //      
double ExtLineBuffer[]; 

//----        
double FATLTable[] = 
 {
  +0.4360409450, +0.3658689069, +0.2460452079, +0.1104506886, -0.0054034585, -0.0760367731, 
  -0.0933058722, -0.0670110374, -0.0190795053, +0.0259609206, +0.0502044896, +0.0477818607, 
  +0.0249252327, -0.0047706151, -0.0272432537, -0.0338917071, -0.0244141482, -0.0055774838, 
  +0.0128149838, +0.0226522218, +0.0208778257, +0.0100299086, -0.0036771622, -0.0136744850, 
  -0.0160483392, -0.0108597376, -0.0016060704, +0.0069480557, +0.0110573605, +0.0095711419, 
  +0.0040444064, -0.0023824623, -0.0067093714, -0.0072003400, -0.0047717710, +0.0005541115, 
  +0.0007860160, +0.0130129076, +0.0040364019
 }; 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
void OnInit()
  {
//----+
   //----    ExtLineBuffer   
   SetIndexBuffer(0, ExtLineBuffer, INDICATOR_DATA);
   //----       FATLShift
   PlotIndexSetInteger(0, PLOT_SHIFT, FATLShift);
   //----      
   PlotIndexSetInteger(0, PLOT_DRAW_BEGIN, FATLPeriod);
   //----      
   string shortname;
   StringConcatenate(shortname, "FATL(", FATLShift, ")");
   //---      DataWindow
   PlotIndexSetString(0, PLOT_LABEL, shortname);   
   //---           
   IndicatorSetString(INDICATOR_SHORTNAME, shortname);
   //---     
   IndicatorSetInteger(INDICATOR_DIGITS, _Digits + 1);
   //---    
   FATLPeriod = ArraySize(FATLTable);
//----+
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const int begin,          //     
                const double &price[]     //     
               )
  {
//----+   
   //----       
   if (rates_total < FATLPeriod - 1 + begin)
    return(0);
   
   //----    
   int first, bar, iii;
   double FATL;
   
   //----    first    
   if (prev_calculated == 0) //      
    { 
     first = FATLPeriod - 1 + begin; //      
     //---      begin ,      
     if(begin > 0)
      PlotIndexSetInteger(0, PLOT_DRAW_BEGIN, begin + FATLPeriod);
    }
   else first = prev_calculated - 1; //      

   //----    
   for(bar = first; bar < rates_total; bar++)
    {
     //----     
     FATL =  0.0;
     for(iii = 0; iii < FATLPeriod; iii++)
      FATL += FATLTable[iii] * price[bar - iii];
      
     //----       FATL
     ExtLineBuffer[bar] = FATL;
    }
//----+     
   return(rates_total);
  }
//+------------------------------------------------------------------+
