/*
 *         
 * SmoothAlgorithms.mqh
 *   (): MetaTrader\\MQL5\Include
 */
//+X================================================================X+ 
//|                                                       J2JMA_.mq5 | 
//|                             Copyright  2010,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+X================================================================X+ 
#property copyright "Copyright  2010, Nikolay Kositsin"
#property link "farria@mail.redcom.ru"
//----   
#property version   "1.00"
//----     
#property indicator_chart_window 
//----   
#property indicator_buffers 1 
//----     
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----     
#property indicator_type1   DRAW_LINE
//----        
#property indicator_color1 Magenta 
//----   -  
#property indicator_style1  STYLE_SOLID
//----     1
#property indicator_width1  1
//----   
#property indicator_label1  "J2JMA"
//+-----------------------------------+
//|         |
//+-----------------------------------+
enum Applied_price_ // 
 {
  PRICE_CLOSE_ = 1,     //PRICE_CLOSE
  PRICE_OPEN_,          //PRICE_OPEN
  PRICE_HIGH_,          //PRICE_HIGH
  PRICE_LOW_,           //PRICE_LOW
  PRICE_MEDIAN_,        //PRICE_MEDIAN
  PRICE_TYPICAL_,       //PRICE_TYPICAL
  PRICE_WEIGHTED_,      //PRICE_WEIGHTED
  PRICE_SIMPL_,         //PRICE_SIMPL_
  PRICE_QUARTER_,       //PRICE_QUARTER_
  PRICE_TRENDFOLLOW0_, //PRICE_TRENDFOLLOW0_
  PRICE_TRENDFOLLOW1_  //PRICE_TRENDFOLLOW1_
 };
input int Length1 = 5; //     
input int Length2 = 5; //                        
input int Phase1  = 100; //   ,
                                 //   -100 ... +100,
                                           //    ;
input int Phase2  = 100;  //   ,
                                 //   -100 ... +100,
                                           //    ;
input Applied_price_ IPC = PRICE_CLOSE_;// 
  /* ,      ( 1-CLOSE, 2-OPEN, 3-HIGH, 4-LOW, 
  5-MEDIAN, 6-TYPICAL, 7-WEIGHTED, 8-SIMPL, 9-QUARTER, 10-TRENDFOLLOW, 11-0.5 * TRENDFOLLOW.) */ 
input int Shift = 0; //      
input int PriceShift = 0; // c     
//---+
//----  
double J2JMA[];

int start = 60;
double dPriceShift;
//+X================================================================X+
//   CJJMA                                             |
//+X================================================================X+ 
#include <SmoothAlgorithms.mqh> 
//+X================================================================X+    
//| J2JMA indicator initialization function                          | 
//+X================================================================X+  
void OnInit()
 {
//----+  
  //----      
  SetIndexBuffer(0, J2JMA, INDICATOR_DATA);
  //----    1  
  PlotIndexSetInteger(0, PLOT_SHIFT, Shift);
  //----      
  PlotIndexSetInteger(0, PLOT_DRAW_BEGIN, start + 1);
  //---      DataWindow
  PlotIndexSetString(0, PLOT_LABEL, "J2JMA");
  //----   ,      
  PlotIndexSetDouble(0, PLOT_EMPTY_VALUE, EMPTY_VALUE);
  //----      
  string shortname;
  StringConcatenate(shortname, "J2JMA( Length1 = ", Length1, ", Length2 = ", Length2, ")");  
  //---           
  IndicatorSetString(INDICATOR_SHORTNAME, shortname);
  //---     
  IndicatorSetInteger(INDICATOR_DIGITS, _Digits + 1);
  //----    CJJMA   JJMASeries_Cls.mqh
  CJJMA JMA;
  //----       
  JMA.JJMALengthCheck("Length1", Length1);
  JMA.JJMALengthCheck("Length2", Length2);
  //----       
  JMA.JJMAPhaseCheck("Phase1", Phase1);
  JMA.JJMAPhaseCheck("Phase2", Phase2);
  //----    
  dPriceShift = _Point * PriceShift;
//----+  
 }
//+X================================================================X+  
//| J2JMA iteration function                                         | 
//+X================================================================X+  
int OnCalculate
               (
                const int rates_total, //       
                const int prev_calculated, //       
                const int begin, //     
                const double &price[] //     
               ) 
  {
//----+   
   start += begin;
   //----       
   if (rates_total < start) return(0);
    
   //----       
   double j1jma, j2jma;
   //----+        
   int first, bar;
   
   //----    first    
   if (prev_calculated == 0) //      
        first = begin; //      
   else first = prev_calculated - 1; //      
   
   //----    CJJMA   JJMASeries_Cls.mqh
   static CJJMA JMA1, JMA2;
   
   //----    
   for(bar = first; bar < rates_total; bar++)
    {
     //----+    JJMASeries. 
     // Phase  Length      (Din = 0)
     //    begin   30 . .   JMA   
     j1jma = JMA1.JJMASeries(begin, prev_calculated, rates_total, 0, Phase1, Length1, price[bar], bar, false);
     j2jma = JMA2.JJMASeries(begin + 30, prev_calculated, rates_total, 0, Phase2, Length2,      j1jma, bar, false);
     //----       
     J2JMA[bar] = j2jma + dPriceShift;
    }
//----+     
   return(rates_total);
  }
//+X----------------------+ <<< The End >>> +-----------------------X+
