/*
 *         
 * SmoothAlgorithms.mqh
 *   (): MetaTrader\\MQL5\Include
 */
//+X================================================================X+ 
//|                                                         MAx2.mq5 | 
//|                               Copyright  2010, Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+X================================================================X+ 
#property copyright "Copyright  2010, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//----   
#property version   "1.00"
//----     
#property indicator_chart_window 
//----   
#property indicator_buffers 1 
//----     
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----     
#property indicator_type1   DRAW_LINE
//----        
#property indicator_color1 Salmon
//----   -  
#property indicator_style1  STYLE_SOLID
//----     2
#property indicator_width1  2
//----  
#property indicator_label1  "MAx2"
//+-----------------------------------+
//|         |
//+-----------------------------------+
input int Length1 = 12; //  
input ENUM_MA_METHOD MA_Method1 = MODE_SMA; //   
input int Length2 = 3; //    
input ENUM_MA_METHOD MA_Method2 = MODE_LWMA; //                      
input int Shift = 0; //      
input int PriceShift = 0; //      
//+-----------------------------------+
//----  
double MAx2[];

int start = 0;
double dPriceShift;
//+X================================================================X+
//   Moving_Average                                    | 
//+X================================================================X+  
#include <SmoothAlgorithms.mqh> 
//+X================================================================X+    
//| _2MA indicator initialization function                           | 
//+X================================================================X+  
void OnInit()
 {
//----+  
  //----      
  SetIndexBuffer(0, MAx2, INDICATOR_DATA);
  //----    1  
  PlotIndexSetInteger(0, PLOT_SHIFT, Shift);
  //----      
  if (MA_Method1 != MODE_EMA) start = Length1 - 1;
  if (MA_Method2 != MODE_EMA) start  += Length2;
  PlotIndexSetInteger(0, PLOT_DRAW_BEGIN, start);
  //----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE, EMPTY_VALUE);
  //---      DataWindow
  PlotIndexSetString(0, PLOT_LABEL, "MAx2"); 
  //----      
  string shortname;
  StringConcatenate(shortname, "MAx2( Length1 = ", Length1, ", Length2 = ", Length2, ")");  
  //---           
  IndicatorSetString(INDICATOR_SHORTNAME, shortname);
  //---     
  IndicatorSetInteger(INDICATOR_DIGITS, _Digits + 1);
  //----    
  dPriceShift = _Point * PriceShift;
//----+  
 }
//+X================================================================X+  
//| _2MA iteration function                                          | 
//+X================================================================X+  
int OnCalculate
               (
                const int rates_total, //       
                const int prev_calculated, //       
                const int begin, //     
                const double &price[] //     
               ) 
  {
//----+
   start += begin;   
   //----       
   if (rates_total < start) return(0);

   //----   
   int first, bar;
   //----       
   double ma1, ma2;
   //----   
   static int start1, start2;
   
   //----     OnCalculate()
   if (prev_calculated == 0) //      
    {
     first = begin; //      
     
     //----     
     start1 = begin;
     if (MA_Method2 != MODE_EMA) 
          start2 = Length1 + begin;
     else start2 = begin;
     
     //---      begin ,
           //      
     if(begin > 0) PlotIndexSetInteger(0, PLOT_DRAW_BEGIN, start);
    }
   else first = prev_calculated - 1; //      
     
   //----    Moving_Average   MASeries_Cls.mqh
   static CMoving_Average MA1, MA2;
   
   //----    
   for(bar = first; bar < rates_total; bar++)
    {
     //----+    MASeries.  
     ma1 = MA1.MASeries(start1, prev_calculated, rates_total, Length1, MA_Method1, price[bar], bar, false);
     ma2 = MA2.MASeries(start2, prev_calculated, rates_total, Length2, MA_Method2, ma1,        bar, false);
     //----       
     MAx2[bar] = ma2 + dPriceShift;
    }
//----+     
   return(rates_total);
  }
//+X----------------------+ <<< The End >>> +-----------------------X+
