/*
 *         
 * SmoothAlgorithms.mqh
 *   (): MetaTrader\\MQL5\Include
 */
//+X================================================================X+ 
//|                                                         MAx4.mq5 | 
//|                               Copyright  2010, Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+X================================================================X+ 
#property copyright "Copyright  2010, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//----   
#property version   "1.00"
//----     
#property indicator_chart_window 
//----   
#property indicator_buffers 1 
//----     
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----     
#property indicator_type1   DRAW_LINE
//----        - 
#property indicator_color1 DarkOrchid
//----   -  
#property indicator_style1  STYLE_SOLID
//----     2
#property indicator_width1  2
//----   
#property indicator_label1  "MAx4"
//+-----------------------------------+
//|         |
//+-----------------------------------+
input int Length1 = 3; //   SMA 
input int Length2 = 3; //   EMA 
input int Length3 = 3; //   SMMA  
input int Length4 = 3; //   LWMA                     
input int Shift = 0; //      
input int PriceShift = 0; //      
//+-----------------------------------+
//----  
double MAx4[];

int start;
double dPriceShift;
//+X================================================================X+
//   CMoving_Average                                   | 
//+X================================================================X+ 
#include <SmoothAlgorithms.mqh> 
//+X================================================================X+    
//| MAx4 indicator initialization function                           | 
//+X================================================================X+  
void OnInit()
 {
//----+  
  //----      
  SetIndexBuffer(0, MAx4, INDICATOR_DATA);
  //----    1  
  PlotIndexSetInteger(0, PLOT_SHIFT, Shift);
  //----     
  start  = Length1  + Length3 + Length4;
  //----      
  PlotIndexSetInteger(0, PLOT_DRAW_BEGIN, start);
  //----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE, EMPTY_VALUE);
  //---      DataWindow
  PlotIndexSetString(0, PLOT_LABEL, "MAx4"); 
  //----      
  string shortname;
  StringConcatenate(shortname, "MAx4( SMA Length = ", Length1, ", EMA Length = ", Length2,
                                         ", SMMA Length = ", Length3, ", LWMA Length = ", Length4, ")");  
  //---           
  IndicatorSetString(INDICATOR_SHORTNAME, shortname);
  //---     
  IndicatorSetInteger(INDICATOR_DIGITS, _Digits + 1);
  //----    
  dPriceShift = _Point * PriceShift;
//----+  
 }
//+X================================================================X+  
//| MAx4 iteration function                                          | 
//+X================================================================X+  
int OnCalculate
               (
                const int rates_total, //       
                const int prev_calculated, //       
                const int begin, //     
                const double &price[] //     
               ) 
  {
//----+
   start += begin;   
   //----       
   if (rates_total < start) return(0);

   //----   
   int first, bar;
   //----       
   double ma1_, ma2_, ma3_, ma4_;
   //----   
   static int start1, start2, start3, start4;
   
   //----     OnCalculate()
   if (prev_calculated == 0) //      
    {
     first = begin; //      
     
     //----     
     start1 = 0 + begin;
     start2 = Length1 + begin-1;
     start3 = Length1 + begin-1; //  EMA      
     start4 = Length1 + Length3 + begin-2;
     
     //---      begin ,
           //      
     //if(begin > 0) PlotIndexSetInteger(0, PLOT_DRAW_BEGIN, start);
    }
   else first = prev_calculated - 1; //      
     
   //----    CMoving_Average   MASeries_Cls.mqh
   static CMoving_Average MA1, MA2, MA3, MA4;
   
   //----    
   for(bar = first; bar < rates_total; bar++)
    {
     //----+    MASeries.  
     ma1_ = MA1.MASeries(start1, prev_calculated, rates_total, Length1, MODE_SMA,  price[bar], bar, false);
     ma2_ = MA2.MASeries(start2, prev_calculated, rates_total, Length2, MODE_EMA,  ma1_,       bar, false);
     ma3_ = MA3.MASeries(start3, prev_calculated, rates_total, Length3, MODE_SMMA, ma2_,       bar, false);
     ma4_ = MA4.MASeries(start4, prev_calculated, rates_total, Length4, MODE_LWMA, ma3_,       bar, false);
     //----       
     MAx4[bar] = ma4_ + dPriceShift;
    }
//----+     
   return(rates_total);
  }
//+X----------------------+ <<< The End >>> +-----------------------X+
