/*
 *         
 * SmoothAlgorithms.mqh
 *   (): MetaTrader\\MQL5\Include
 */
//+X================================================================X+
//|                                                        VIDYA.mq5 |
//|              MQL5 Code:     Copyright  2010,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+X================================================================X+
//----  
#property copyright "Copyright  2010, Nikolay Kositsin"
#property link "farria@mail.redcom.ru"
//----   
#property version   "1.00"
//----     
#property indicator_chart_window
//----        
#property indicator_buffers 1
//----     
#property indicator_plots   1
//----     
#property indicator_type1   DRAW_LINE
//----        
#property indicator_color1  Gold
//----   -  
#property indicator_style1  STYLE_SOLID
//----     2
#property indicator_width1  2
//----   
#property indicator_label1  "VIDYA"

//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input int CMO_period = 9; //  VIDYA
input double EMA_period = 12; //  EMA
input int VIDYAShift = 0; //      
input int PriceShift = 0; // c     
//+----------------------------------------------+
//----   ,    
                //      
double ExtLineBuffer[]; 

double dPriceShift;
//+X================================================================X+
//   CCMO                                              |
//+X================================================================X+   
#include <SmoothAlgorithms.mqh>  
//+X================================================================X+
//| Custom indicator initialization function                         |
//+X================================================================X+  
void OnInit()
  {
//----+
   //----    ExtLineBuffer   
   SetIndexBuffer(0, ExtLineBuffer, INDICATOR_DATA);
   //----       VIDYAShift
   PlotIndexSetInteger(0, PLOT_SHIFT, VIDYAShift);
   //----      
   PlotIndexSetInteger(0, PLOT_DRAW_BEGIN, CMO_period);
   //----      
   string shortname;
   StringConcatenate(shortname, "VIDYA(", CMO_period, ")");
   //---      DataWindow
   PlotIndexSetString(0, PLOT_LABEL, shortname);   
   //---           
   IndicatorSetString(INDICATOR_SHORTNAME, shortname);
   //---     
   IndicatorSetInteger(INDICATOR_DIGITS, _Digits + 1);
   //---      
   PlotIndexSetDouble(0, PLOT_EMPTY_VALUE, EMPTY_VALUE);
   //----    
   dPriceShift = _Point * PriceShift;
//----+
  }
//+X================================================================X+
//| Custom indicator iteration function                              |
//+X================================================================X+
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const int begin,          //     
                const double &price[]     //     
               )
  {
//----+   
   //----       
   if (rates_total < CMO_period + 1 + begin)
    return(0);
   
   //----    
   int first, bar; 

   //----    first    
   if (prev_calculated == 0) //      
    { 
     first = 0 + begin; //      
     //---      begin ,      
     if(begin > 0) PlotIndexSetInteger(0, PLOT_DRAW_BEGIN, CMO_period + 2 + begin);
    }
   else 
    {
     first = prev_calculated - 1; //      
    }

   //----    VIDYA
   static CCMO VIDYA1;

   //----    
   for(bar = first; bar < rates_total; bar++)
     ExtLineBuffer[bar] = VIDYA1.VIDYASeries(begin, prev_calculated, rates_total, CMO_period,
                                                     EMA_period, price[bar], bar, false) + dPriceShift;
//----+     
   return(rates_total);
  }
//+------------------------------------------------------------------+
