//+X================================================================X+ 
//|                                                        iMAx4.mq5 | 
//|                               Copyright  2010, Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+X================================================================X+ 
#property copyright "Copyright  2010, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//----   
#property version   "1.00"
//----     
#property indicator_chart_window 
//----   
#property indicator_buffers 1 
//----     
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----     
#property indicator_type1   DRAW_LINE
//----        - 
#property indicator_color1 DarkOrchid
//----   -  
#property indicator_style1  STYLE_SOLID
//----     2
#property indicator_width1  2
//----   
#property indicator_label1  "iMAx4"
//+-----------------------------------+
//|         |
//+-----------------------------------+
input int Length1 = 3; //   SMA 
input int Length2 = 3; //   EMA 
input int Length3 = 3; //   SMMA  
input int Length4 = 3; //   LWMA                     
input int Shift = 0; //      
input int PriceShift = 0; //      
//+-----------------------------------+
//----  
double iMAx4[];

int Handle;
int start;
double dPriceShift;
//+X================================================================X+    
//| iMAx4 indicator initialization function                          | 
//+X================================================================X+  
void OnInit()
 {
//----+  
  //----      
  SetIndexBuffer(0, iMAx4, INDICATOR_DATA);
  //----    1  
  PlotIndexSetInteger(0, PLOT_SHIFT, Shift);
  //----     
  start  = Length1  + Length3 + Length4;
  //----      
  PlotIndexSetInteger(0, PLOT_DRAW_BEGIN, start);
  //----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE, EMPTY_VALUE);
  //---      DataWindow
  PlotIndexSetString(0, PLOT_LABEL, "iMAx4"); 
  //----      
  string shortname;
  StringConcatenate(shortname, "iMAx4( SMA Length = ", Length1, ", EMA Length = ", Length2,
                                         ", SMMA Length = ", Length3, ", LWMA Length = ", Length4, ")");  
  //---           
  IndicatorSetString(INDICATOR_SHORTNAME, shortname);
  //---     
  IndicatorSetInteger(INDICATOR_DIGITS, _Digits + 1);
  //----    
  dPriceShift = _Point * PriceShift;
  
  //----+   
  Handle = iMA(NULL, 0, Length1, 0, MODE_SMA, PRICE_CLOSE);
  if (Handle == INVALID_HANDLE)Print("      iMA");
  Handle = iMA(NULL, 0, Length2, 0, MODE_EMA, Handle);
  if (Handle == INVALID_HANDLE)Print("      iMA");
  Handle = iMA(NULL, 0, Length3, 0, MODE_SMMA, Handle);
  if (Handle == INVALID_HANDLE)Print("      iMA");
  Handle = iMA(NULL, 0, Length3, 0, MODE_LWMA, Handle);
  if (Handle == INVALID_HANDLE)Print("      iMA");
  
  //----+       
  ArraySetAsSeries(iMAx4, true);
//----+  
 }
//+X================================================================X+  
//| iMAx4 iteration function                                         | 
//+X================================================================X+  
int OnCalculate
               (
                const int rates_total, //       
                const int prev_calculated, //       
                const int begin, //     
                const double &price[] //     
               ) 
  {
//----+
   start += begin;   
   //----       
   if (rates_total < start) return(0);
   
   int to_copy;
   
   if(prev_calculated > rates_total || prev_calculated <= 0)//      
    {
     to_copy = rates_total - begin; //    
     
     //---      begin ,
           //      
     if(begin > 0) PlotIndexSetInteger(0, PLOT_DRAW_BEGIN, start);
    }
   else to_copy = rates_total - prev_calculated + 1; //     
   
   //---       
   if(CopyBuffer(Handle, 0, 0, to_copy, iMAx4) <= 0) return(0);
//----+     
   return(rates_total);
  }
//+X----------------------+ <<< The End >>> +-----------------------X+
